VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsARPATimeServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

' Autor: Florian Rittmeier Florian@ActiveVB.de

' Beschreibung: Implementation eines TimeServers(STD 26) in einer Klasse

Option Explicit

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Enum ServerError
    WSStillUsed = 1 ' Winsock-Control noch in Benutzung
    WinsockError = 2 ' Winsock-Fehler
    NoWS = 3 ' Kein Winsock-Control wurde dem Server zgeordnett
End Enum

Public Event TimeRequested(ByVal RequestTime As Date, ByVal RequestIP As String)
Public Event Error(ByVal ErrorType As ServerError, ByVal Details As String)

Dim WithEvents ws As Winsock
Attribute ws.VB_VarHelpID = -1
Dim Running As Boolean ' Ob der Server aktiv ist
Dim SendCompleted As Boolean ' Zur berprfung wann die Verbindung geschlossen werden kann

Public Sub StartServer()
If Running Then Exit Sub

If ws Is Nothing Then
    RaiseEvent Error(NoWS, "Connect a Winsock-Control!")
    Exit Sub
End If

ws.LocalPort = 37
ws.Listen

Running = True
End Sub

Public Sub StopServer()
If Not Running Then Exit Sub

Running = False
If ws.State = sckListening Then ws.Close

' Falls sich der Server noch in einer Kommunikation befindet
While Not ws.State = sckClosed
    DoEvents
Wend

' Alles Aufrumen
Set ws = Nothing
End Sub
Public Property Set ServerWS(ByRef SWS As Winsock)
' Dem Server muss ein Winsock-Control zugeordnet werden.
' Man knnte zwar auch probieren ber CreateObject ein entsprechendes
' Control zu instanzieren, allerdings kann dann z.B. der Verpackungsassistent
' nicht mehr erkennen, dass das Winsock-Control bentigt wird

If ws Is Nothing Then
    Set ws = SWS
Else
    RaiseEvent Error(WSStillUsed, "Stop the Server before attaching a new Winsock-Control")
End If
End Property

Private Sub Class_Terminate()
If Running Then StopServer
End Sub

Private Sub ws_ConnectionRequest(ByVal requestID As Long)
' WS frei machen
ws.Close
' Verbindung akzeptieren
ws.Accept requestID

' warten bis verbunden wurde
While Not ws.State = sckConnected
    DoEvents
Wend

SendCompleted = False

' Bescheidgeben das die Uhrzeit angefragt wird
RaiseEvent TimeRequested(Now, ws.RemoteHostIP)

Dim temp As Long
' Achtung, die Variable "temp" wird hier missbraucht.
' VB-Longs sind eigentlich signed.
' In diesem Fall wird aber einfach so getan,
' als sei die Variable ein unsigned long.

' Uhrzeit ermitteln
temp = GetMsFrom1900

' bertragen der 4 Bytes aus dem Long in ein Bytearray
' um sie in umgekehrter Reihenfolge senden zu knnen.
Dim b(0 To 3) As Byte
Call CopyMemory(ByVal VarPtr(b(0)), ByVal VarPtr(temp), 4)

Dim i As Integer
For i = 3 To 0 Step -1
    ws.SendData b(i)
Next

' Warten bis alle 4 Bytes bertragen wurden
While Not SendCompleted
    DoEvents
Wend

' Verbindung schlieen
ws.Close

' Warten bis die Verbindung geschlossen wurde
While Not ws.State = sckClosed
    DoEvents
Wend

If Running Then ws.Listen
End Sub

Private Sub ws_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
RaiseEvent Error(WinsockError, Number & ": " & Description)
End Sub

Private Sub ws_SendComplete()
SendCompleted = True
End Sub

Private Function GetMsFrom1900() As Long
Dim GMTAbweichung As Long
GMTAbweichung = 2 * 60 * 60
' Die Verwendung der obigen Zeile ist eigentlich nicht richtig.
' Damit der Server immer und an jedem Ort die richtige Zeitzone
' auswhlt, sollte noch der Tipp 340 mit eingebaut werden, da
' sich mit diesem sehr einfach ermitteln lsst,
' wie genau die Abweichung zur GMT ist.

Dim msfrom1990 As Long
msfrom1990 = DateDiff("s", #1/1/1990#, Now) - GMTAbweichung

Dim msfrom1900 As Double
msfrom1900 = CDbl(msfrom1990) + 2840140800#

GetMsFrom1900 = DblToLong(msfrom1900)
End Function

'########################################################
'###### Die folgende Function ist aus dem VB-Forum ######
'######       die engltige Version wurde von      ######
'######      daniel <danny_good55@hotmail.com>     ######
'######                  gepostet.                 ######
'########################################################

' Diese Funktion wandelt einen Double,
' sofern es sich um einen positiven Double handelt
' der in einen unsigned Long passt, in einen solchen um.

Private Function DblToLong(Value As Double) As Long
  If Value > 4294967295# Or _
     Value < 0 Or _
     Int(Value) <> Value Then
    Err.Raise 5
  Else
    If Value > &H7FFFFFFF Then
      DblToLong = Value - 4294967296#
    Else
      DblToLong = Value
    End If
  End If
End Function

